10

Educational Codeforces Round 62 Editorial

 2 years ago
source link: http://codeforces.com/blog/entry/66147
Go to the source link to view the article. You can view the picture content, updated content and better typesetting reading experience. If the link is broken, please click the button below to view the snapshot at that time.
By awoo, history, 3 years ago, translation, In English

1140A - Detective Book

Tutorial
Solution (adedalic)

1140B - Good String

Tutorial
Solution (Roms)

1140C - Playlist

Tutorial
Solution (Roms)

1140D - Minimum Triangulation

Tutorial
Solution (adedalic)

1140E - Palindrome-less Arrays

Tutorial
Solution (adedalic)

1140F - Extending Set of Points

Tutorial
Solution (BledDest)

1140G - Double Tree

Tutorial
Solution (BledDest)

3 years ago, # |

51769222 this is my submission for problem c why is it giving wrong answer

  • 3 years ago, # ^ |

    Rev. 2  

    +4

    Because long somtimes is just int. So to prevent this mistake everytime write "long long". UPD: When you think int isn't enough

    • 3 years ago, # ^ |

      Thanks

    • 13 months ago, # ^ |

      This is very true.

3 years ago, # |

In Problem D, yes I got AC with greedy solution but How to Do using DP (recursive approach)

At first during contest i started to solve this question as top down dp(recursive), but i was not able to solve.. can someOne give there dp recursive solution..

  • 3 years ago, # ^ |

    The comment is hidden because of too negative feedback, click here to view it
    • 3 years ago, # ^ |

      @bhatnagar.mradul bro u are trying to implement that greedy solution using dp.. i dont mean that..

      i want to know that O(n^3) solution using recursive dp

      • 3 years ago, # ^ |

        dp(i,j)=min(dp(i,k)+dp(k,j)+i*k*j) for all k varies from i+1 to j-1 partition the polygon into two polygon (i,k) and (k,j) and one triangle

      • 3 years ago, # ^ |

        I used O(N^2) dp

        dp[i][j] means answer for polygon that is made from this points -> [1,2...i] and [n,n-1,...j].

        dp[i+1][j]=min(dp[i+1][j],dp[i][j]+i*(i+1)*j)
        dp[i][j-1]=min(dp[i][j-1],dp[i][j]+i*(j-1)*j)

        You need to update answer when i+1==j-1.
        My solution.

  • 3 years ago, # ^ |

    Rev. 2  

    +7

    Keep two pointers as state. dp[i][j] should have the optimal total cost of triangulation of the polygon with { i, i+1, i+2, ..., j-1, j } vertices. To calculate dp[i][j] you have to take the line i-j at some point in a triangle. Pick a vertex k such that i < k < j and make a triangle { i, j, k }.

    So dp[i][j] = min { i*j*k + dp[i][k] + dp[k][j] } for all k such that i < k < j.

    Result is dp[1][n]. Code if needed.

3 years ago, # |

can F be solved with sqrt-dynamic connectivity trick?

  • 3 years ago, # ^ |

    Rev. 2  

    +10

    I tried, but I haven't managed to squeeze my O(q1.5)O(q1.5) implementation in time limit. But it doesn't mean that it's impossible, considering my optimization skills.

    Sometimes actually O(q1.5logq)O(q1.5log⁡q) version can be faster, maybe I'll try that.

  • 3 years ago, # ^ |

    can I find any tutorial for that ?

3 years ago, # |

Problem C, editorial:

This can be done using some standard containers: set in C++

multiset, because two songs can be equal

  • 3 years ago, # ^ |

    you can insert pair, with second equal to index, this guaranties uniqueness.

    • 2 months ago, # ^ |

      I have used multiset but it gives TLE, Although set and multiset have same time complexity. Can you say it why that happens?

3 years ago, # |

Rev. 2  

+6

In problem E, What is the difference between l is odd and l is even ? I think the way to compute cntDiff and cntSame when l is odd is similar when l is even ?

  • 3 years ago, # ^ |

    when l is odd then (**#**) you can't split it into tow same segment . the different of those just that .

    • 3 years ago, # ^ |

      I mean we can use recipe when l is even for both case,can't we?

      • 3 years ago, # ^ |

        You can, but it will drop complexity from O(logl)O(log⁡l) to O(l)O(l). It doesn't matter in this specific task, but it worse overall.

3 years ago, # |

can anyone explain the problem E , i didn't understood the editorial

  • 3 years ago, # ^ |

    If you have palindrome of size ODDNUMBER, you also have palindrome of size ODDNUMBER — 2. So you just avoid palindromes of length 3 and that's enough.

    Split the array A into two smaller arrays ODD and EVEN, odd indices goes into ODD, even indices go into EVEN. You want to answer this question:

    "How many ways are there to fill in -1, so that no adjacent numbers are the same"

    Solve that question for the two arrays, final answer is simply solve(EVEN)*solve(ODD)

3 years ago, # |

For the solution of problem C, what if the erased item from the set is actually the one just inserted? e.g., suppose we insert one a[i] that has the smallest beauty as well as the shortest length, and if the set size exceeds k, the element that will be popped out will be a[i]. But at the end of this iteration, we compute the score by a[i].first still, which is formally wrong.

But this may not cause trouble: since sum doesn't change in this case, and a[i].first should be smaller than any song in the set, so that a[i].first * sum <= min_beauty(s).first * sum; this implies that the maximal value won't be polluted by a[i].first * sum, and the actual score has been considered.

  • 3 years ago, # ^ |

    Great observation!

  • 2 years ago, # ^ |

    can u please give some mathematical proof of C.. that is why we sort on the basis of beauty.. in my opinion if we multiply beauty and length and then sort is it work???.... plz help me?? I can't understand...Thanks

  • 13 months ago, # ^ |

    Can you explain more how it will not cause an error?

3 years ago, # |

Probably the best solution for Problem D. here:- https://codeforces.com/contest/1140/submission/51801930

Approach For n = 3 the cut will 1-3. ans = 1*2*3

For n = 4 the cuts will be 1-3, 1-4. ans = 1*2*3 + 1*3*4

for n = 5 the cuts will be 1-3, 1-4, 1-5. ans = 1*2*3 + 1*3*4 + 1*4*5

If we look at the pattern then for n = N, the ans will be 1*2*3 + 1*3*4 + 1*4*5 + 1*5*6 + ... + 1*(N-1)*(N) which can be written as sum from n = 2 to N : n(n+1)

changing limit of n from 2 to 1, we need to subtract 1*2, i.e 2 from the result

(sum from n = 1 to N : n(n+1) )- 2 (sum from n = 1 to N : n^2 + n) — 2

sum from n = 1 to N : n^2 = (n(n+1)(2n+1))/6 sum from n = 1 to N : n = (n(n+1))/2 ans = (n(n+1)(2n+1))/6 + (n(n+1))/2 — 2;

ans = (n(n+1)(n+2))/3 — 2;

all you need to do is take the input n, decrement n by 1; ans use the above formula.

Time Complexity — O(1) Space Complexity — O(1)

  • 49 minutes ago, # ^ |

    How did you get the formula n(n+1)?

3 years ago, # |

Can anybody please explain G's solution? I'm not getting the editorial.

  • 3 years ago, # ^ |

    Rev. 2  

    0

    1. First we need to find the shortest path between nodes of the form 2i−12i−1 to 2i2i. This can be done with a dp on the tree. Notice that any such shortest path will only take one edge between the even tree and the odd tree. Simply replacing the cross edge distance will not change shortest distances, and will make reasoning through the problem easier.

    2. Next to find shortest paths, if you use centroid decomposition we can find shortest path from root to a node by:

    • dp[i][j] defined to be the length of the shortest path from node 2i−j2i−j to the root with another tree dp.

    If you use binary jumping, you can use: - dp[i][j][k][l] defined to be the the distance from 2i−j2i−j to the 2l2l th ancestor in either the even or odd tree (kept track of by k).

    I personally find binary jumping easier. Either way, this uses the critical observation that if you want to find the path from one node to another, you need to pass through the simple path on the tree between the two nodes (possibly jumping back and forth between the trees).

3 years ago, # |

In the end we need to find a way to calculate the number of those sequences. There are only two fundamental types of sequences: (a == b) and (a != b). Exact values of a and b don't really matter

I believe this part can be simplified a bit. Write the usual dynamic dp[n][k] and notice that we actually need only 2 states instead of k: dp[i][j == a] and dp[i][j != a]

3 years ago, # |

In Problem E, How do we get cntSame(0) = 0 and cntDiff(0) = 1 and how this relation is coming out when l is even or odd. Can someone explain with example.

  • 3 years ago, # ^ |

    cntSame(0) = 0 since there is no way to make 'aa' have all pairs of consecutive elements are distinct. cntDiff(0) = 1 since there is one way to make 'ab' have all pairs of consecutive elements are distinct.

3 years ago, # |

Why don't precompute values cntSame and cntDiff for every 1<=i<=n in O(n) using dp?

3 years ago, # |

Can we solve C with dynamic programming is there any optimal substructure for the problem.

3 years ago, # |

In F, it says "...using path compression in DSU here is meaningless...". Is it meaningless? I think it can actually make the solution slower, since path compression is amortized, and if the structure allows undoing operations, then amortization should fail (might give TLE on countertests).

3 years ago, # |

In problem E, there is no need to make separate recurrence relation for odd and even lengths as mentioned in the tutorial. The one for even length is enough to get for the odd length.

cntSame(l)=(k−1)⋅cntDiff(l−1)

cntDiff(l)=cntSame(l−1)+(k−2)⋅cntDiff(l−1).

link to the code

  • 3 years ago, # ^ |

    Sorry to bother you, could you explain how did you get that recurrence on problem E? I'm having trouble on find it.

    • 3 years ago, # ^ |

      theProcess Consider a -1 -1 ...ltimes... -1 -1 b

      You need to find the no. of arrays in which no two consecutive elements are equal.

      So first if you assign the value to the lth "-1" element i.e. element before b, obviously you can assign all the values to it from 1 to k, except b. You can't assign b to it because no two consecutive elements should be equal. So there are (k-1) ways in which you can assign the value to lth "-1" element.

      Now I hope you know the meaning of cntSame(l), and cntDiff(l).

      To calculate cntSame(l), consider what happens when a=b.

      Suppose you assign value to p to the lth "-1" element. Obviously, p!=b.

      Since a=b, therefore p!=a. So, remaining number of values will be (k-1) i.e. except a(or b, since a=b). Therefore cntSame(l) = (k-1)*cntDiff(l-1)

      To calculate cntDiff(l), consider what happens when a!=b.

      Suppose you assign value to p to the lth "-1" element. Obviously, p!=b.

      Since a!=b, You can either assign p=a or p!=a. There will be exactly one case to assign p=a and (k-2) cases to assign p!=a. (k-2 because you cannot also assign p=b)

      Therefore cntDiff(l) = cntSame(l-1) + (k-2)*cntDiff(l-1)

  • 3 years ago, # ^ |

    Hi, In problem E, why do we need to look into the two different cases of sequences possible .i.e., a -1 -1 ... -1 b , a==b and a!= b ? Can we not simply iterate through the elements and whenever there is a -1 , it can take either k-1 values (if the next element is -1) or k-2 values(if the next element != -1). Why wouldn't this work ? Thank you :)

3 years ago, # |

I read many solutions for problem E. What I understood is we have to find continuous sequences of -1 for even and odd positions separately and apply recurrence to calculate number of ways such that consecutive numbers should be different and multiply results for both even and odd positions. What I didn't understood is how numbers other than -1 affect the total number of ways and how recurrence works for them. Can anyone please explain it ?

3 years ago, # |

In problem C When we sliding the window for the sum of length, shouldn't we include the current element with least beauty value? I mean, what we're really finding is the most (k-1) elements we've searched before but not k because the length of ith one is included must?

  • 3 years ago, # ^ |

    https://codeforces.com/contest/1140/submission/52462663

    yes the length of the i'th one must be included.

    so the idea is to consider every i'th element as the minimum beauty. for this we sort the songs in descending order of beauty. so the first song we consider will have the highest beauty. (what if 2 songs have same beauty? read last 2 para)

    we will at all times try to maintain a list of songs of size at most k. this list will contain at most k songs with the highest length, not including the current i'th song. so if we already have a list of size k, then we remove the song with the smallest length. so size become k-1. then we include the current song into the list, size becomes k, and update our maxTillNow. if out list is less than k, then we just simply include the song and update maxTillNow.

    to maintain this list we will use a priority_queue (min heap), where the top element is the song with the smallest length. this way we don't need to keep track of song indexes.

    while sorting our list of songs in descending order of beauty, if 2 songs have the same beauty we place the song with the smaller length first (this is very important). this is because when we consider the i'th beauty, obviously the i'th length must also be included. which means, if there is already a song in the list with the same beauty as our current minimum beauty we need to pick the one with the smaller length to discard.

    this process becomes easier to deal with for 2 or more songs with same beauty, if we consider the song with the greater length as late as possible. because the song with the smaller length will already be in the list, so we can simply discard it and include the current song.

    read code for more clarity.

3 years ago, # |

Rev. 2  

0

Hi, In problem E, why do we need to look into the two different cases of sequences possible .i.e., a -1 -1 ... -1 b , a==b and a!= b ? Can we not simply iterate through the elements and whenever there is a -1 , it can take either k-1 values (if the next element is -1) or k-2 values(if the next element != -1). Why wouldn't this work ?

3 years ago, # |

Rev. 2  

0

Can anyone tell the complexity of the for loop dealing with set in C?

  • 3 years ago, # ^ |

    only 1 time loop will execute for each outer loop. So we could have used if condition (instead of iterating over set) as well because at a time, its gauranteed, set size can only be 'k' at max, since we are increasing set size by 1 in each outer loop iteations.

3 years ago, # |

Problem statement of 1140 A is highly confusing.

3 years ago, # |

why I don't understand the Problem B.I think the answer of string "<<<<>>>>" should be 1,because we can do some operations,finally the string will be "<>",then the answer is 1 .

  • 3 years ago, # ^ |

    You may remove some characters from the string before applying the operations.

    • 3 years ago, # ^ |

      Oh,thank you very much

      • 5 months ago, # ^ |

        Rev. 2  

        0

        hi!can you tell me if string is "<<<<>>>>",then why the answer is 4 and not 1?

    • 3 years ago, # ^ |

      In problem C,I cannot understand why the does the set use pair<int,int> instead of int .In other words,if I submit my code with set 《int》 ,then I will wrong on test 3 .It seems that we haven't utilize the second of the pair<int,int>. Sorry for my poor English.

      • 3 years ago, # ^ |

        Set does not contain duplicate elements. but we need to store it. pair<int,int> is used for this reason. Because index itself is stored with the beauty value, there is no chance for duplicate elements.

        • 3 years ago, # ^ |

          Oh,I understand.Thank you for solving my problem.

3 years ago, # |

My opinion may be subjective, but problem A was very poorly written and hard to comprehend exactly what is being asked.

2 years ago, # |

Approach and Solution of (D. Minimum Triangulation)... for n=3 cut will be 1-3 -------------------- ans=1*2*3 for n=4 cut will be 1-3,1-4----------------- ans=(1*2*3)+(1*3*4) for n=5 cut will be 1-3,1-4,1-5------------- ans=(1*2*3)+(1*3*4)+(1*4*5) ......so on

Solution will be for(int i=2;i<n;i++) ans+=i*(i+1); // no need to multiply by 1 print(ans);

dry run of above code....for n=5; when i=2 ----ans=2*3 i.e ans=6 // no need to multiply by 1 / when i=3 ----ans=3*4 +ans i.e ans=18 / when i=4------ans=(4*5)+ans; i.e ans=38.....

Hope u understand......

20 months ago, # |

Note that the triangulation problem can be solved in constant time using discrete Taylor's theorem (centered about 3):

6(n-3 choose 0) + 12(n-3 choose 1) + 8(n-3 choose 2) + 2(n-3 choose 3)

Because the values of k in any given choose statement are bounded (0 <= k <= 4), the combinatoric function is simple and essentially constant time (using (n^k_)/k!).

15 months ago, # |

Rev. 2  

0

In problem C when I used set st it wont work but if I use set<pair<int,int>>st it does work

  • 15 months ago, # ^ |

    Set does not contain duplicate elements. but we need to store it. pair<int,int> is used for this reason. Because index itself is stored with the beauty value, there is no chance for duplicate elements.(copied)

    • 15 months ago, # ^ |

      Thanks man

15 months ago, # |

in 1140C can anybody tell what is the use making PAIR there. its giving wrong answer of 3rd testcase if I am not making a paired set.

12 months ago, # |

problem C has got weak test cases!!

11 months ago, # |

Solution of problem C 1140C - Playlist using set from editorial which is getting WA 102264302 , but when changed set to multiset it gets Accepted 102264669 Can anyone tell me why this is happening?

7 months ago, # |

In problem C: what if deleted element from pair of set is the element just inserted? i mean its possible that we deleted the just inderted element but we multiplied its beauty-> res = max(res, sum * a[i].first);

doing this doesn't makes any sense..

7 months ago, # |

Rev. 3  

+8

I'm a bit confused on problem G's solution. As an example, on a normal tree, how could we precompute the distance from each centroid to every node in its centroid decomposition subtree? I can think of a brute force O(nlog22n)O(nlog22n) solution using a method like binary jumping and precomputing all the possibilities, but this pretty much defeats the purpose of using centroid decomposition to solve this problem. Is there some sort of efficient O(nlog2n)O(nlog2n) DFS solution that I'm missing? Thanks in advance

Edit: I figured it out already


Recommend

About Joyk


Aggregate valuable and interesting links.
Joyk means Joy of geeK